//===================================CISCKER====================================
//=================================Memory Unit==================================
//------------------------------------------------------------------------------
//File Name:	memory.v
//Purpose:		Von-Neumann memory Unit
//Parameters:	None
//------------------------------------------------------------------------------
//=====================Alfredo Gualdron - Jose P. Pinilla=======================
//=================================Semillero ADT================================
//================================UPB Bucaramanga===============================
//Website:	http://semilleroadt.upbbga.edu.co/xiscker
//E-mail:	semilleroadt@gmail.com
//------------------------------------------------------------------------------
module memory(
		//control
		input we,
		input clk_90,
		input wd_src,
		//in
		input [15:0] MDR,
		input [15:0] MAR,
		//out
		output [7:0] Mem_data
		);

//reg [7:0] ML = 0;
//wire [7:0]ML;

//Input Byte Selection

wire [7:0] write_data = (wd_src) ? MDR[7:0] : MDR[15:8];

RAM	RAM_inst (
	.address (MAR),
	.clock (clk_90),
	.data (write_data),
	.wren (we),
	.q (Mem_data)
	);

/*
(*RAM_STYLE="BLOCK"*)
reg [7:0]Mem[32766:0];
 
initial $readmemh("instructions.dat", Mem);

always @ (posedge clk_90)
	if (we)
		Mem[MAR] <= write_data;
	else
		ML <= Mem[MAR];
*/
//Output logic (8bit and 16bit data signed or unsigned)

//If data isn't signed, H will be cleared accordign to h_reset control signal	
		
endmodule
